import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import 'Tile.dart';

class DisplayPlateauWidget extends StatefulWidget {
  @override
  _DisplayPlateauWidgetState createState() => _DisplayPlateauWidgetState();
}

class _DisplayPlateauWidgetState extends State<DisplayPlateauWidget> {
  double _currentSliderValue=4;
  TextStyle textStyle = TextStyle(fontSize: 16, fontWeight: FontWeight.bold,);

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text("Affichage du plateau"),
      ),
      body: Center(
          child: ListView(
          children: [
            SizedBox(
                width: 500.0,
                height: 400.0,
                child: Container(
                    margin: EdgeInsets.all(20.0),
                    child: createGridView())),
            Row(mainAxisSize: MainAxisSize.min,
                children: <Widget>[
                  Container(width: 90,child:Text('Taille:', style: textStyle,textAlign: TextAlign.center,),padding: EdgeInsets.fromLTRB(8, 0, 0, 0),),
                  Container(width: MediaQuery.of(context).size.width-90,child: Slider(
                      value: _currentSliderValue,
                      min: 1, max: 10, divisions: 9,
                      label: _currentSliderValue.round().toString(),
                      onChanged: (double value) {
                        setState(() {_currentSliderValue = value;});
                      }
                    ),
                  ),
                ]
            ),
          ])),
    );
  }

  Widget createGridView() {
    return GridView.count(
        padding: const EdgeInsets.all(10),
        mainAxisSpacing: 5,
        crossAxisSpacing: 5,
        crossAxisCount: _currentSliderValue.toInt(),
        children: getAllCroppedImage(createListTile(_currentSliderValue)),
    );
  }

  List<Widget> getAllCroppedImage(List<Tile> liste){
    List<Widget> res=<Widget>[];
    for(int i=0; i<liste.length;i++){
      res.add(liste[i].croppedImageTile());
    }
    return res;
  }

  List<Tile> createListTile(double size){
    List<Tile> res=<Tile>[];

    for(double i=-1.0;i<=1.0;){
      for(double j=-1.0;j<=1.0;){
        res.add(new Tile( image: Image.network('https://picsum.photos/512/1024'), alignment: Alignment(j, i),size: size));
        j+=(2/(size-1));
      }
      i+=(2/(size-1));
    }
    return res;
  }
}

